## aspcud 1.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
	message(SEND_ERROR  "You have to create an out-of-source build")
	message(SEND_ERROR  "Create a sub-folder and execute cmake there")
	message(FATAL_ERROR "The file CmakeCache.txt and directory CMakeFiles in the root directory have to be deleted manually now")
endif()

# user configurables
set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type: Release Debug")

project(aspcud)

include(cmake/re2c.cmake)
include(cmake/lemon.cmake)

IF(USE_STATIC_LIBS)
	set(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)
	set(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
	set(CMAKE_SHARED_LIBRARY_C_FLAGS)
	set(CMAKE_SHARED_LIBRARY_CXX_FLAGS)
	set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS)
	set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
	set(Boost_USE_STATIC_LIBS TRUE)
	set(CMAKE_EXE_LINKER_FLAGS "-static")
	set(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a)
ENDIF()

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake CACHE INTERNAL "" FORCE)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE INTERNAL "" FORCE)
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib CACHE INTERNAL "" FORCE)

IF(EXISTS "${CMAKE_SOURCE_DIR}/libboost/")
	include_directories("libboost")
ELSE()
	set(Boost_USE_MULTITHREADED OFF CACHE STRING "Whether to Use multi-threaded boost libraries")
	find_package(Boost REQUIRED)
	#find_package(Boost COMPONENTS filesystem system)
	include_directories(${Boost_INCLUDE_DIRS})
ENDIF()

add_subdirectory(libcudf)
add_subdirectory(libprogram_opts)
add_subdirectory(app)

=== Makefile ===
all: release

debug:
	mkdir -p build/debug
	cd build/debug && \
		cmake ../.. \
		-DCMAKE_CXX_FLAGS=-Wall \
		-DCMAKE_BUILD_TYPE=debug && \
	$(MAKE)

release:
	mkdir -p build/release
	cd build/release && \
	cmake ../.. \
		-DCMAKE_BUILD_TYPE=release && \
	$(MAKE)

static:
	mkdir -p build/static
	cd build/static && \
	cmake ../.. \
		-DCMAKE_BUILD_TYPE=release -DUSE_STATIC_LIBS=true && \
	$(MAKE)

clean:
	rm -rf build

=== app/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/libcudf ${CMAKE_SOURCE_DIR}/libprogram_opts .)

set(cudf-libs cudf-lib program_opts-lib ${Boost_LIBRARIES})

add_executable(cudf-app main.cpp)
target_link_libraries(cudf-app ${cudf-libs})
set_target_properties(cudf-app PROPERTIES OUTPUT_NAME cudf2lp)

=== libcudf/CMakeLists.txt ===
file(GLOB_RECURSE LIBCUDF_SRC    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.cpp *.h)
file(GLOB_RECURSE LIBCUDF_LEXER  RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.r2c)
file(GLOB_RECURSE LIBCUDF_PARSER RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.y)

include_directories(src .)

RE2C(LIBCUDF_SRC ${LIBCUDF_LEXER})
LEMON(LIBCUDF_SRC ${LIBCUDF_PARSER})

add_library(cudf-lib STATIC ${LIBCUDF_SRC})

target_link_libraries(cudf-lib)
set_target_properties(cudf-lib PROPERTIES OUTPUT_NAME cudf)

=== debian/changelog ===
aspcud (1:1.8.0-2) unstable; urgency=low

  * Fix package autotest (closes: #735138). Thanks to Matthias Klose and
    Martin Pitt for their indications!
    - add dependency of the test on aspcud
    - send all output to stderr instead of /dev/null, allow test to
      produce output on stderr
    - fix location of input directory
    - use /tmp for temporary files when TMPDIR not set
  * Add dependency on python, needed by scripts/aspcud.sh

 -- Ralf Treinen <treinen@debian.org>  Tue, 14 Jan 2014 10:51:17 +0100

aspcud (1:1.8.0-1) unstable; urgency=low

  * New upstream release. This version runs with gringo 4 (closes: #733494)
  * debian/control: add XS-Testsuite.
  * Adapt patches to new upstream: pathes, add-trendy-criterion.
  * bump dependency on gringo to >= 4
  * restrict dependency on clasp to << 3.
  * put test cases from version 2012.10.24 into debian/tests/cudf and 
    modify debian/tests/upstream accordingly since this upstream release 
    does not contain any test cases.

 -- Ralf Treinen <treinen@debian.org>  Sat, 11 Jan 2014 09:13:51 +0100

aspcud (2012.10.24-6) unstable; urgency=medium

  * Upload with urgency medium to migrate to testing before gringo 4
  * Put version constraint (<< 4) on dependency on gringo, following info
    received from upstream.
  * Standards-Version 3.9.5 (no change).
  * Add as-installed package test:
    - add DEP-8 style debian/tests/control
    - add debian/tests/upstream test script

 -- Ralf Treinen <treinen@debian.org>  Tue, 17 Dec 2013 21:53:08 +0100

aspcud (2012.10.24-5) unstable; urgency=low

  * debian/solvers/aspcud: quote arguments to allow for shell metacharacters
    in arguments. Thanks to Pietro Abate for the hint.

 -- Ralf Treinen <treinen@debian.org>  Wed, 09 Oct 2013 21:02:43 +0200

aspcud (2012.10.24-4) unstable; urgency=low

  * add sed script /usr/share/aspcud/misc11-to-misc12 based on an idea by
    Roberto Di Cosmo (thanks!)
  * Patch misc11-backward-compatiblity: translate optimization criteria
    in MISC11 style to MISC12.

 -- Ralf Treinen <treinen@debian.org>  Sat, 29 Jun 2013 10:41:01 +0200

aspcud (2012.10.24-3) unstable; urgency=low

  * Fix changelog entry of previous upload (experimental -> unstable)
  * debian/control: update vcs-* fields (collab-maint git on alioth)
  * drop debian/svn-deblayout, add debian/gbp.conf (force pristine-tar)
  * debian/copyright: drop comment on omitting file cmake/macros.cmake
    that does no longer apply 

 -- Ralf Treinen <treinen@debian.org>  Fri, 24 May 2013 22:25:40 +0200

aspcud (2012.10.24-2) unstable; urgency=low

  * upload to unstable

 -- Ralf Treinen <treinen@debian.org>  Fri, 10 May 2013 22:46:41 +0200

aspcud (2012.10.24-1) experimental; urgency=low

  * New upstream release (upstream svn release 5904)
  * debian/patches:
    - pathes: refreshed for new upstream version
    - no-cmake-errors: dropped since adopted upstream
    - gcc4.6: dropped since adopted upstream
    - clasp-2.1-apichange: dropped since we now build for clasp 2.1 only
    - added cmake-use-environment: makes the toplevel Makefile pass
      environment variables to cmake. Thanks to Roland Kaminski for the patch.
    -added add-trendy-criterion: make aspcud recognize the "trendy"
      optimisation criterion.
  * debian/control:
    - bump dependency on clasp to >= 2.1 since this is needed by this
      upstream version
    - bump debhelper compatibility level, and version of the build-dependency
      on debhelper, to 9. Needed to pass dpkg-build-flags to Makefile.
    - Standards-version 3.9.4 (no change)
  * debian/copyright: add copyright field for lemon/* (public domain)

 -- Ralf Treinen <treinen@debian.org>  Sun, 04 Nov 2012 16:34:51 +0100

aspcud (2011.03.17.dfsg-6) unstable; urgency=low

  * Restored build-dependency on libboost-dev which was accidentially
    changed in the last upload.
  * Restored changelog-entry of version 2011.03.17.dfsg-4 that was 
    accidentially mangled in the upload of 2011.03.17.dfsg-5.

 -- Ralf Treinen <treinen@debian.org>  Fri, 07 Sep 2012 10:33:50 +0900

aspcud (2011.03.17.dfsg-5) unstable; urgency=low

  * Patch clasp-2.1-apichange: make aspcud work both with clasp 2.0 and
    clasp 2.1. Thanks a lot to Roland Kaminski for the patch
    (closes: #686356).
  * debian/copyright:
    - Fixed typo (Licence -> License)
    - separate paragraph for the GPL3 license
    - text of the "public domain" license.
  
 -- Ralf Treinen <treinen@debian.org>  Sun, 02 Sep 2012 22:54:51 +0900

aspcud (2011.03.17.dfsg-4) unstable; urgency=low

  * Replace build-dependency on libboost1.46-dev by libboost-dev (closes:
    #672752)
  * standards-version 3.9.3
  * debian/copyright: add Format line of machine-readable format 1.0,
       fix spelling, copyright of lemon/*

 -- Ralf Treinen <treinen@debian.org>  Mon, 14 May 2012 21:02:50 +0200

aspcud (2011.03.17.dfsg-3) unstable; urgency=low

  * source package: put solver specification in debian/solvers/ascpcud
  * install more stuff through dh_install
  * solver specification: use interpolation variables for arguments

 -- Ralf Treinen <treinen@debian.org>  Fri, 10 Jun 2011 20:40:39 +0200

aspcud (2011.03.17.dfsg-2) unstable; urgency=low

  * patch gcc4.6: fix FTBFS with gcc-4.6. Patch extracted from upstream
    svn (closes: #625071)

 -- Ralf Treinen <treinen@debian.org>  Mon, 02 May 2011 22:46:38 +0200

aspcud (2011.03.17.dfsg-1) unstable; urgency=low

  * Intial upload (closes: #623601)

 -- Ralf Treinen <treinen@debian.org>  Sun, 24 Apr 2011 17:28:26 +0200

=== debian/control ===
Source: aspcud
Section: admin
Priority: extra
Maintainer: Ralf Treinen <treinen@debian.org>
Build-Depends: debhelper (>= 9),
  libboost-dev (>= 1.46), cmake (>= 2.6), re2c
Standards-Version: 3.9.5
Homepage: http://www.cs.uni-potsdam.de/wv/aspcud/
Vcs-Git: git://git.debian.org/git/collab-maint/aspcud.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/aspcud.git;a=summary
XS-Testsuite: autopkgtest

Package: aspcud
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 python,
 gringo (>= 4),
 clasp (>= 2.1.0), clasp (<< 3)
Provides: cudf-solver
Description: CUDF solver based on Answer Set Programming
 Aspcud is an experimental solver for package dependencies. A package
 universe and a request to install, remove or upgrade packages have
 to be encoded in the CUDF format.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_clean:
	-rm -rf build/release/*

override_dh_auto_install:
	cp scripts/aspcud.sh debian/aspcud/usr/bin/aspcud

## aspcud 1.9.0

=== debian/changelog ===
aspcud (1:1.9.0-2) unstable; urgency=medium

  * add debian/watch

 -- Ralf Treinen <treinen@debian.org>  Sat, 21 Jun 2014 11:00:37 +0200

aspcud (1:1.9.0-1) experimental; urgency=low

  * New upstream release. Drop patches that are now obsolete:
    - pathes
    - cmake-use-environment
    - add-trendy-criterion
    - misc11-backward-compatiblity
  * Use install target provided by upstream:
    - drop target override_dh_auto_install in debian/rules
    - remove now obsolete entries from debian/aspcud.install
  * Add version constraint on build-dependency re2c, according to INSTALL
  * Bump versions on dependencies clasp and gringo, according to INSTALL
  * Drop dependency on python which is no longer needed. Yeah!
  * debian/tests/upstream: add one user criterion from each misc11 and misc12
  * debian/aspcud.manpages: install upstream's manpage instead of our own

 -- Ralf Treinen <treinen@debian.org>  Wed, 05 Mar 2014 21:41:02 +0100 

aspcud (1:1.8.0-3) unstable; urgency=low
  * migrate to clasp 3:
    - bump version in build-dependency on clasp
    - add patch clasp3 provided by upstream
  * add version to build-dependency on re2c, according to INSTALL file

 -- Ralf Treinen <treinen@debian.org>  Wed, 26 Feb 2014 21:07:49 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Ralf Treinen <treinen@debian.org>
 Build-Depends: debhelper (>= 9),
-  libboost-dev (>= 1.46), cmake (>= 2.6), re2c
+  libboost-dev (>= 1.46), cmake (>= 2.6), re2c (>= 0.13)
 Standards-Version: 3.9.5
 Homepage: http://www.cs.uni-potsdam.de/wv/aspcud/
 Vcs-Git: git://git.debian.org/git/collab-maint/aspcud.git
@@ -13,9 +13,8 @@
 Package: aspcud
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends},
- python,
- gringo (>= 4),
- clasp (>= 2.1.0), clasp (<< 3)
+ gringo (>= 4.2.1),
+ clasp (>= 3.0.0), clasp (<< 4)
 Provides: cudf-solver
 Description: CUDF solver based on Answer Set Programming
  Aspcud is an experimental solver for package dependencies. A package

## aspcud 1.9.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,13 +6,11 @@
 	message(FATAL_ERROR "The file CmakeCache.txt and directory CMakeFiles in the root directory have to be deleted manually now")
 endif()
 
-# user configurables
-set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type: Release Debug")
-
 project(aspcud)
 
 include(cmake/re2c.cmake)
 include(cmake/lemon.cmake)
+include(GNUInstallDirs)
 
 IF(USE_STATIC_LIBS)
 	set(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)
@@ -43,3 +41,6 @@
 add_subdirectory(libprogram_opts)
 add_subdirectory(app)
 
+install(FILES "${CMAKE_SOURCE_DIR}/share/aspcud/misc2012.lp" "${CMAKE_SOURCE_DIR}/share/aspcud/specification.lp" DESTINATION "${CMAKE_INSTALL_DATADIR}/aspcud")
+install(FILES "${CMAKE_SOURCE_DIR}/man/man1/aspcud.1" "${CMAKE_SOURCE_DIR}/man/man1/cudf2lp.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")
+

=== app/CMakeLists.txt ===
--- 
+++ 
@@ -6,3 +6,35 @@
 target_link_libraries(cudf-app ${cudf-libs})
 set_target_properties(cudf-app PROPERTIES OUTPUT_NAME cudf2lp)
 
+set(ENCODING_LOC "" CACHE STRING "optional to overwrite default path to encoding")
+set(CUDF2LP_LOC  "" CACHE STRING "optional to overwrite default path to cudf2lp")
+set(GRINGO_LOC   "" CACHE STRING "optional to overwrite default path to gringo")
+set(CLASP_LOC    "" CACHE STRING "optional to overwrite default path to clasp")
+
+if (CUDF2LP_LOC)
+	set_property(SOURCE aspcud.c APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_CUDF2LP_BIN=\"${CUDF2LP_LOC}\"")
+else()
+	set_property(SOURCE aspcud.c APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_CUDF2LP_BIN=\"${CMAKE_INSTALL_PREFIX}/bin/cudf2lp\"")
+endif()
+if (GRINGO_LOC)
+	set_property(SOURCE aspcud.c APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_GRINGO_BIN=\"${GRINGO_LOC}\"")
+else()
+	set_property(SOURCE aspcud.c APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_GRINGO_BIN=\"${CMAKE_INSTALL_PREFIX}/bin/gringo\"")
+endif()
+if (CLASP_LOC)
+	set_property(SOURCE aspcud.c APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_CLASP_BIN=\"${CLASP_LOC}\"")
+else()
+	set_property(SOURCE aspcud.c APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_CLASP_BIN=\"${CMAKE_INSTALL_PREFIX}/bin/clasp\"")
+endif()
+if (ENCODING_LOC)
+	set_property(SOURCE aspcud.c APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_DEFAULT_ENCODING=\"${ENCODING_LOC}\"")
+else()
+	set_property(SOURCE aspcud.c APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_DEFAULT_ENCODING=\"${CMAKE_INSTALL_PREFIX}/share/aspcud/misc2012.lp\"")
+endif()
+
+set_property(SOURCE main.cpp APPEND PROPERTY COMPILE_FLAGS "-ftemplate-depth=256")
+
+add_executable(aspcud-app aspcud.c)
+set_target_properties(aspcud-app PROPERTIES OUTPUT_NAME aspcud)
+
+install(TARGETS cudf-app aspcud-app RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== lemon/CMakeLists.txt ===
ADD_EXECUTABLE(lemon lemon.c)
EXPORT(TARGETS lemon FILE ${CMAKE_BINARY_DIR}/import_lemon.cmake)

=== libcudf/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,8 @@
 file(GLOB_RECURSE LIBCUDF_SRC    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.cpp *.h)
 file(GLOB_RECURSE LIBCUDF_LEXER  RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.r2c)
 file(GLOB_RECURSE LIBCUDF_PARSER RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.y)
+file(GLOB_RECURSE TEST_SRC       RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} test/*.cpp test/*.h)
+
 
 include_directories(src .)
 
@@ -12,3 +14,17 @@
 target_link_libraries(cudf-lib)
 set_target_properties(cudf-lib PROPERTIES OUTPUT_NAME cudf)
 
+find_package(Boost COMPONENTS unit_test_framework)
+
+if(Boost_UNIT_TEST_FRAMEWORK_FOUND)
+    if("${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}" MATCHES ".*\\.((so)|(dll)|(dynlib))$")
+            add_definitions("-DBOOST_TEST_DYN_LINK")
+    endif()
+
+    add_executable(test-app EXCLUDE_FROM_ALL ${TEST_SRC})
+	target_link_libraries(test-app cudf-lib ${Boost_LIBRARIES})
+    set_target_properties(test-app PROPERTIES OUTPUT_NAME test)
+    
+    add_custom_target(test COMMAND test-app DEPENDS test-app)
+endif()
+

=== libprogram_opts/CMakeLists.txt ===
file(GLOB_RECURSE LIBPROGRAM_OPTS_SRC src/*.cpp *.h)

include_directories(src .)

add_library(program_opts-lib STATIC ${LIBPROGRAM_OPTS_SRC})

target_link_libraries(program_opts-lib)
set_target_properties(program_opts-lib PROPERTIES OUTPUT_NAME program_opts)

=== debian/changelog ===
aspcud (1:1.9.1-2) unstable; urgency=low

  * Patch check-criteria: check whether field names used in optimisation
    criteria are default fields, or declared in the preamble of the cudf
    document. Thanks to Roland Kaminski for the patch! (closes: #780899)

 -- Ralf Treinen <treinen@debian.org>  Wed, 17 Jun 2015 20:27:04 +0200

aspcud (1:1.9.1-1) unstable; urgency=low

  * New upstream release.
  * debian/aspcud.dirs: drop empty directory usr/lib/aspcud/bin
  * Standards-version 3.9.6 (no change).
  * debian/control: XS-Testsuite => Testsuite
  * debian/control: canonize URI in VCS fields

 -- Ralf Treinen <treinen@debian.org>  Wed, 27 May 2015 07:44:32 +0200

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Maintainer: Ralf Treinen <treinen@debian.org>
 Build-Depends: debhelper (>= 9),
   libboost-dev (>= 1.46), cmake (>= 2.6), re2c (>= 0.13)
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.cs.uni-potsdam.de/wv/aspcud/
-Vcs-Git: git://git.debian.org/git/collab-maint/aspcud.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/aspcud.git;a=summary
-XS-Testsuite: autopkgtest
+Vcs-Git: git://anonscm.debian.org/collab-maint/aspcud.git
+Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/aspcud.git
+Testsuite: autopkgtest
 
 Package: aspcud
 Architecture: any

=== debian/watch ===
version=2
http://sf.net/potassco/aspcud-(\d\S*)-source\.tar\.gz

## aspcud 1.9.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

file(READ "libcudf/cudf/version.hh" cudfh)
string(REGEX MATCH "#define CUDF_VERSION \"([^\"]*)\"" cudfv ${cudfh})

project(aspcud VERSION "${CMAKE_MATCH_1}" LANGUAGES C CXX)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS ON)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(lemon)
include(functions)
include(GNUInstallDirs)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

option(ASPCUD_BUILD_STATIC "link aspcud statically" OFF)
option(ASPCUD_BUILD_TESTS "build tests" ON)

set(ASPCUD_ENCODING_PATH     "" CACHE STRING "optional to overwrite default path to the encoding")
set(ASPCUD_CUDF2LP_PATH      "" CACHE STRING "optional to overwrite default path to cudf2lp")
set(ASPCUD_GRINGO_PATH       "" CACHE STRING "optional to overwrite default path to gringo")
set(ASPCUD_CLASP_PATH        "" CACHE STRING "optional to overwrite default path to clasp")

mark_as_advanced(ASPCUD_BUILD_STATIC)
mark_as_advanced(ASPCUD_ENCODING_PATH)
mark_as_advanced(ASPCUD_CUDF2LP_PATH)
mark_as_advanced(ASPCUD_GRINGO_PATH)
mark_as_advanced(ASPCUD_CLASP_PATH)

if (NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
endif()
if (NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()
if (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()
if (NOT CMAKE_IMPORT_LIBRARY_PREFIX)
    set(CMAKE_IMPORT_LIBRARY_PREFIX import_)
endif()

if(ASPCUD_BUILD_STATIC)
    set(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)
    set(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
    set(CMAKE_SHARED_LIBRARY_C_FLAGS)
    set(CMAKE_SHARED_LIBRARY_CXX_FLAGS)
    set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS)
    set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
    set(Boost_USE_STATIC_LIBS TRUE)
    set(Boost_USE_MULTITHREADED OFF)
    set(CMAKE_EXE_LINKER_FLAGS "-static")
    set(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a)
endif()

find_package(RE2C)
find_package(Boost REQUIRED)

if(NOT TARGET Boost::boost)
  add_library(Boost::boost INTERFACE IMPORTED)
  if(Boost_INCLUDE_DIRS)
    set_target_properties(Boost::boost PROPERTIES
      INTERFACE_INCLUDE_DIRECTORIES "${Boost_INCLUDE_DIRS}")
  endif()
endif()

enable_testing()

add_subdirectory(libcudf)
add_subdirectory(app)

=== lemon/CMakeLists.txt ===
source_group("Source Files" FILES lemon.c lempar.c)

add_executable(lemon lemon.c)
export(TARGETS lemon FILE ${CMAKE_BINARY_DIR}/import_lemon.cmake)

=== libcudf/tests/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/catch.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/criteria.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/critparser.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/helpers.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/other.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

add_executable(test_libcudf ${header} ${source})
target_link_libraries(test_libcudf PRIVATE libcudf Boost::boost)

add_test(NAME test_libcudf COMMAND test_libcudf)

=== debian/changelog ===
aspcud (1:1.9.4-1) unstable; urgency=medium

  * New upstream release
    - drop patches lemon-gcc7 and check-criteria which are already applied
      in this upstream version.
  * debian/watch: new upstream repo at github
  * debian/copyright:
    - license changed to MIT
    - separate files under GPL3 are no longer part of the release
    - add public-domain for file .ycm_extra_conf.py
    - update source address
    - update copyright year
    - use https in url of format spec
  * drop debian/aspcud.manpages which is no longer needed.
  * Standards-version 4.1.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Sun, 24 Sep 2017 12:39:48 +0200

aspcud (1:1.9.1-3) unstable; urgency=medium

  * Patch lemon-gcc7: update lemon for gcc-7 (closes: #872668).
  * d/control: dropped redundant Testsuite field.
  * Standards-Version 4.0.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Sun, 10 Sep 2017 20:06:13 +0200

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,10 @@
 Maintainer: Ralf Treinen <treinen@debian.org>
 Build-Depends: debhelper (>= 9),
   libboost-dev (>= 1.46), cmake (>= 2.6), re2c (>= 0.13)
-Standards-Version: 3.9.6
+Standards-Version: 4.1.0
 Homepage: http://www.cs.uni-potsdam.de/wv/aspcud/
 Vcs-Git: git://anonscm.debian.org/collab-maint/aspcud.git
 Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/aspcud.git
-Testsuite: autopkgtest
 
 Package: aspcud
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_clean:
	-rm -rf build/release/*

## aspcud 1.9.5

=== app/CMakeLists.txt ===
source_group("Source Files" FILES aspcud.cc cudf2lp.cc options.hh)

add_executable(aspcud aspcud.cc)
target_include_directories(aspcud PRIVATE ${CMAKE_SOURCE_DIR}/libcudf)

add_executable(cudf2lp options.hh cudf2lp.cc)
target_link_libraries(cudf2lp PRIVATE libcudf Boost::boost Boost::disable_autolinking)

install(
    FILES "${CMAKE_SOURCE_DIR}/encodings/misc2012.lp" "${CMAKE_SOURCE_DIR}/encodings/specification.lp"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}")
install(
    FILES "${CMAKE_SOURCE_DIR}/doc/man/aspcud.1" "${CMAKE_SOURCE_DIR}/doc/man/cudf2lp.1"
    DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")

if (NOT ASPCUD_CUDF2LP_PATH)
    set(ASPCUD_CUDF2LP_PATH "${CMAKE_INSTALL_FULL_BINDIR}/cudf2lp${CMAKE_EXECUTABLE_SUFFIX}")
endif()
set_property(SOURCE aspcud.cc APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_CUDF2LP_BIN=\"${ASPCUD_CUDF2LP_PATH}\"")
if (NOT ASPCUD_GRINGO_PATH)
    set(ASPCUD_GRINGO_PATH "${CMAKE_INSTALL_FULL_BINDIR}/gringo${CMAKE_EXECUTABLE_SUFFIX}")
endif()
set_property(SOURCE aspcud.cc APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_GRINGO_BIN=\"${ASPCUD_GRINGO_PATH}\"")
if (NOT ASPCUD_CLASP_PATH)
    set(ASPCUD_CLASP_PATH "${CMAKE_INSTALL_FULL_BINDIR}/clasp${CMAKE_EXECUTABLE_SUFFIX}")
endif()
set_property(SOURCE aspcud.cc APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_CLASP_BIN=\"${ASPCUD_CLASP_PATH}\"")
if (NOT ASPCUD_ENCODING_PATH)
    set(ASPCUD_ENCODING_PATH "${CMAKE_INSTALL_FULL_DATADIR}/${PROJECT_NAME}/misc2012.lp")
endif()
set_property(SOURCE aspcud.cc APPEND PROPERTY COMPILE_DEFINITIONS "ASPCUD_DEFAULT_ENCODING=\"${ASPCUD_ENCODING_PATH}\"")

install(TARGETS cudf2lp aspcud RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== debian/changelog ===
aspcud (1:1.9.5-1ubuntu1) jammy; urgency=medium

  * Update vendored catch2 to 2.13.9 to avoid FTBFS with glibc 2.34

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 13 Apr 2022 10:27:19 +0000

aspcud (1:1.9.5-1) unstable; urgency=medium

  * New upstream release.
    - drop patch fix_boost_174_FTBFS, this has been fixed upstream
  * update debian watch (version 4, urls at github)
  * debian/copyright: drop paragraph about .ycm_extra_conf.py which is
    no longer part of the upstream release.
  * Standards-version 4.6.0 (no change)
  * Add dbian/upstream/metadata

 -- Ralf Treinen <treinen@debian.org>  Mon, 29 Nov 2021 21:48:41 +0100

aspcud (1:1.9.4-3) unstable; urgency=medium

  [ Anton Gladky ]
  * Fix FTBFS against boost_1,74. (closes: #974539)

  [ Ralf Treinen ]
  * Update homepage, thanks to Ivo De Decker (closes: #960879)
  * Build-depend on debian-compat, drop file debian/compat
  * Debhelper compatibility level 13 (no change)
  * Set Rules-Requires-Root=no
  * Standards-Version 4.5.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Thu, 12 Nov 2020 20:37:06 +0100

aspcud (1:1.9.4-2) unstable; urgency=medium

  * Update Vcs-* to salsa
  * Standards-Version 4.3.0
    - replace Priority extra by optional
  * Debhelper compatibility level 11
  * Remove trailing whitespace in changelog
  * Install examples

 -- Ralf Treinen <treinen@debian.org>  Tue, 25 Dec 2018 18:44:23 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: aspcud
 Section: admin
-Priority: extra
-Maintainer: Ralf Treinen <treinen@debian.org>
-Build-Depends: debhelper (>= 9),
+Priority: optional
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ralf Treinen <treinen@debian.org>
+Build-Depends: debhelper-compat (= 13),
   libboost-dev (>= 1.46), cmake (>= 2.6), re2c (>= 0.13)
-Standards-Version: 4.1.0
-Homepage: http://www.cs.uni-potsdam.de/wv/aspcud/
-Vcs-Git: git://anonscm.debian.org/collab-maint/aspcud.git
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/aspcud.git
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
+Homepage: https://potassco.org/aspcud/
+Vcs-Git: https://salsa.debian.org/debian/aspcud.git
+Vcs-Browser: https://salsa.debian.org/debian/aspcud
 
 Package: aspcud
 Architecture: any

=== debian/watch ===
version=4
https://github.com/potassco/aspcud/releases .*/v?(\d\S+)\.tar\.gz

## aspcud 1.9.6

=== libcudf/CMakeLists.txt ===
file(GLOB_RECURSE LIBCUDF_PARSER RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.y)

# [[[header: cudf
set(ide_header_group "Header Files")
set(header-group-cudf
    "${CMAKE_CURRENT_SOURCE_DIR}/cudf/critparser.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/cudf/dependency.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/cudf/lexer_impl.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/cudf/packages.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/cudf/parser.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/cudf/version.hh")
source_group("${ide_header_group}\\cudf" FILES ${header-group-cudf})
set(header
    ${header-group-cudf})
# ]]]
# [[[source: src
re2c_target_or_gen("/src/critlexer.xh")
lemon_target(NAME "critparser_impl" INPUT "src/critparser_impl.y" OUTPUT ${CMAKE_CURRENT_BINARY_DIR})
re2c_target_or_gen("/src/lexer.xh")
lemon_target(NAME "parser_impl" INPUT "src/parser_impl.y" OUTPUT ${CMAKE_CURRENT_BINARY_DIR})
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/src/critlexer.xh"
    ${RE2C_critlexer_OUTPUT}
    "${CMAKE_CURRENT_SOURCE_DIR}/src/critparser.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/dependency.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/lexer.xh"
    ${RE2C_lexer_OUTPUT}
    "${CMAKE_CURRENT_SOURCE_DIR}/src/packages.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/parser.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source-group-critparser_impl
    "${CMAKE_CURRENT_SOURCE_DIR}/src/critparser_impl.y"
    ${LEMON_critparser_impl_OUTPUTS})
source_group("${ide_source_group}\\critparser_impl" FILES ${source-group-critparser_impl})
set(source-group-parser_impl
    "${CMAKE_CURRENT_SOURCE_DIR}/src/parser_impl.y"
    ${LEMON_parser_impl_OUTPUTS})
source_group("${ide_source_group}\\parser_impl" FILES ${source-group-parser_impl})
set(source
    ${source-group}
    ${source-group-critparser_impl}
    ${source-group-parser_impl})
# ]]]

add_library(libcudf STATIC ${header} ${source})
target_include_directories(libcudf
    PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    PRIVATE "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/src>")
target_link_libraries(libcudf PRIVATE Boost::boost)
set_target_properties(libcudf PROPERTIES OUTPUT_NAME cudf FOLDER lib)

if (ASPCUD_BUILD_TESTS)
    add_subdirectory(tests)
endif()

=== debian/changelog ===
aspcud (1:1.9.6-3) unstable; urgency=medium

  * Patch cmake-version: bump up version of cmake (closes: #1112751)
  * Standards-version 4.7.2 (no change)

 -- Ralf Treinen <treinen@debian.org>  Sun, 28 Sep 2025 20:55:15 +0200

aspcud (1:1.9.6-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit.

  [ Ralf Treinen ]
  * Fix cross compilation. Thanks to Helmut Grohne for the patch
    (closes: #1023488).
  * Fix watch file

 -- Ralf Treinen <treinen@debian.org>  Wed, 16 Nov 2022 21:41:13 +0100

aspcud (1:1.9.6-1) unstable; urgency=medium

  * New upstream release (closes: #1017131,#1000852).
  * Standards-Version 4.6.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Mon, 05 Sep 2022 20:28:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: aspcud
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ralf Treinen <treinen@debian.org>
+Maintainer: Ralf Treinen <treinen@debian.org>
 Build-Depends: debhelper-compat (= 13),
   libboost-dev (>= 1.46), cmake (>= 2.6), re2c (>= 0.13)
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://potassco.org/aspcud/
 Vcs-Git: https://salsa.debian.org/debian/aspcud.git

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
override_dh_auto_configure:
       $(CC_FOR_BUILD) -o debian/lemon lemon/lemon.c
       printf 'add_executable(lemon IMPORTED GLOBAL)\nset_property(TARGET lemon
PROPERTY IMPORTED_LOCATION "$(CURDIR)/debian/lemon")\n' > debian/lemon.cmake
       dh_auto_configure -- -DIMPORT_LEMON=$(CURDIR)/debian/lemon.cmake
endif

override_dh_auto_clean:
	-rm -rf build/release/*

=== debian/tests/control ===
Tests: upstream
Depends: @, cudf-tools
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://github.com/potassco/aspcud/tags .*/v?([\d\.]+)\.tar\.gz

## aspcud 2011.03.17.dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

# user configurables
set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type: Release Debug")

project(aspcud)

include(cmake/re2c.cmake)
include(cmake/lemon.cmake)
include(cmake/macros.cmake)

IF(USE_STATIC_LIBS)
	set(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)
	set(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
	set(CMAKE_SHARED_LIBRARY_C_FLAGS)
	set(CMAKE_SHARED_LIBRARY_CXX_FLAGS)
	set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS)
	set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
	set(Boost_USE_STATIC_LIBS TRUE)
	set(CMAKE_EXE_LINKER_FLAGS ${CMAKE_EXE_LINKER_FLAGS} -static)
	set(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a)
ENDIF()

ENSURE_OUT_OF_SOURCE_BUILD("you have to create an out-of-source build")

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake CACHE INTERNAL "" FORCE)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE INTERNAL "" FORCE)
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib CACHE INTERNAL "" FORCE)

IF(EXISTS "${CMAKE_SOURCE_DIR}/libboost/")
	include_directories("libboost")
ELSE()
	set(Boost_USE_MULTITHREADED OFF CACHE STRING "Whether to Use multi-threaded boost libraries")
	find_package(Boost REQUIRED)
	#find_package(Boost COMPONENTS filesystem system)
	include_directories(${Boost_INCLUDE_DIRS})
ENDIF()

add_subdirectory(libcudf)
add_subdirectory(libprogram_opts)
add_subdirectory(app)

=== debian/control ===
Source: aspcud
Section: admin
Priority: extra
Maintainer: Ralf Treinen <treinen@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
  libboost-dev (>= 1.46), cmake (>= 2.6), re2c
Standards-Version: 3.9.3
Homepage: http://www.cs.uni-potsdam.de/wv/aspcud/
Vcs-Svn: https://gforge.info.ucl.ac.be/svn/mancoosi/trunk/updb/debian-packages/aspcud/trunk
Vcs-Browser: https://gforge.info.ucl.ac.be/svn/mancoosi/trunk/updb/debian-packages/aspcud/trunk

Package: aspcud
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, gringo, clasp (>= 2.0.0)
Provides: cudf-solver
Description: CUDF solver based on Answer Set Programming
 Aspcud is an experimental solver for package dependencies. A package
 universe and a request to install, remove or upgrade packages have
 to be encoded in the CUDF format.

## aspcud 2012.10.24

=== debian/control ===
Source: aspcud
Section: admin
Priority: extra
Maintainer: Ralf Treinen <treinen@debian.org>
Build-Depends: debhelper (>= 9),
  libboost-dev (>= 1.46), cmake (>= 2.6), re2c
Standards-Version: 3.9.4
Homepage: http://www.cs.uni-potsdam.de/wv/aspcud/
Vcs-Git: git://git.debian.org/git/collab-maint/aspcud.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/aspcud.git;a=summary

Package: aspcud
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, gringo, clasp (>= 2.1.0)
Provides: cudf-solver
Description: CUDF solver based on Answer Set Programming
 Aspcud is an experimental solver for package dependencies. A package
 universe and a request to install, remove or upgrade packages have
 to be encoded in the CUDF format.
